#include <stdio.h>
main(int argc, char *argv[]) {
    int i, len, ofs;
    unsigned char BASEROM[1052672];
    // Read Base ROM -----------------------
    FILE *fp = fopen(argv[1], "rb");
    fseek(fp, 0, SEEK_END);
    int baseSize = ftell(fp); // Get filesize before rewind
    rewind(fp);
    fread(BASEROM, baseSize, 1, fp);
    fclose(fp);
    // Detect v64 and unswap ---------------
    if(BASEROM[0x00] == 0x37) {
      for(i = 0; i < sizeof(BASEROM); i += 2) {
        BASEROM[i + 0] = BASEROM[i + 0] ^ BASEROM[i + 1];
        BASEROM[i + 1] = BASEROM[i + 0] ^ BASEROM[i + 1];
        BASEROM[i + 0] = BASEROM[i + 0] ^ BASEROM[i + 1];
      }
    }
    // Detect Base ROM (first digit of CRC)
    switch(BASEROM[0x10]) {
      case 0x4E: // ultraMSX2
        ofs = 0x2DF48; len = 131072;
        break;
      case 0xF2: // ultraSMS
        ofs = 0x1B410; len = 524288;
        break;
    }
    // Load ROM to inject ------------------
    FILE *fp3 = fopen(argv[2], "rb");
    for (i = ofs; i < ofs + len; i++) {
        BASEROM[i] = fgetc(fp3);
    }
    fclose(fp3);
    // Write final ROM ---------------------
    FILE *fp2 = fopen("patched.z64", "wb");
    fwrite(BASEROM, 1, sizeof(BASEROM), fp2);
    fclose(fp2);
    return 0;
}